#include "pipe_paging.h"

PipePaging::PipePaging()
{
}

/* Add a region to the sequence. */

void PipePaging::add_region(PageMapper *mapper)
{
    _regions.push_back(mapper);
}

/* Return the first region in the sequence. */

PageMapper *PipePaging::first_region()
{
    return _regions.front();
}

/* Return the next region for the reader. If only a single region remains, with
   the reader wishing to move to the next, return NULL. */

PageMapper *PipePaging::next_region()
{
    if (_regions.size() > 1)
    {
        _regions.pop_front();
        return _regions.front();
    }
    else
        return NULL;
}

// vim: tabstop=4 expandtab shiftwidth=4
