#pragma once

#include <list>

#include "page_mapper.h"

/* Pipe paging support, maintaining the sequence of active regions or sections
   in a pipe. */

class PipePaging
{
protected:
    std::list<PageMapper *> _regions;

public:
    explicit PipePaging();

    virtual void add_region(PageMapper *mapper);

    virtual PageMapper *first_region();

    virtual PageMapper *next_region();
};

// vim: tabstop=4 expandtab shiftwidth=4
