#pragma once

#include "pages.h"



/* A page collection where the pages are "conserved", meaning that they are not
   queued for reuse unless they are completely unused. */

class PagesConserving : public Pages
{
protected:
    unsigned int _increment;

public:
    explicit PagesConserving(Memory *memory, unsigned int increment=1);

    explicit PagesConserving();

    /* Specialised methods. */

    virtual Flexpage *flexpage();

    virtual void queue(PageOwner *owner, Flexpage *flexpage);

    virtual bool reserve(PageOwner *owner, Flexpage *flexpage);

    /* Memory control methods. */

    virtual bool decrease();

    virtual bool increase();

    virtual offset_t allocation();
};

// vim: tabstop=4 expandtab shiftwidth=4
